﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=12.5
@EndOfDesignText@
#Event: dayclick, prevclick, nextclick, todayclick
#RaisesSynchronousEvents: dayclick, prevclick, nextclick, todayclick
Sub Class_Globals
	Private xui As XUI
	Private act As Activity	'ignore
	Private mCallback As Object
	Private mEventname As String
	Public lblticks As Long
	Private pnlpicker As Panel
	Public lblseldate As Label
	Public folder As String
	Public rp As RuntimePermissions
End Sub
Public Sub Initialize(Callback As Object, Eventname As String)
	mCallback = Callback
	mEventname = Eventname
	lblseldate.Initialize("")
	folder = rp.GetSafeDirDefaultExternal("")
End Sub
Public Sub set_month_panel(mnth As Int, yr As Int,seq As Int) As Panel
	Private daynumber As Int = 1
	Private	currentticks As Long = DateTime.Now
	Private currentmonth As Int = DateTime.GetMonth(currentticks)
	Private currentyear As Int = DateTime.GetYear(currentticks)
	Private currentday As Int = DateTime.GetDayOfMonth(currentticks)
	Private firstdayticks As Long
	Private leftpos As Int = 0dip
	Private toppos As Int = 0dip
	Dim scale As Float = GetDeviceLayoutValues.Scale
	Dim screensize As Double = GetDeviceLayoutValues.ApproximateScreenSize
	Dim devwidth As Int = GetDeviceLayoutValues.Width/scale
	Dim devheight As Int = (GetDeviceLayoutValues.height/scale) - 40dip	 ' title bar height not included
	If screensize > 8 Then
		Dim devwidth As Int = GetDeviceLayoutValues.Width
		Dim devheight As Int = GetDeviceLayoutValues.height - 80dip	 ' title bar height not included
	End If
	Private boxwidth As Int = DipToCurrent(devwidth/7)
	Private boxheight As Int = DipToCurrent(devheight/8)
	Private pnl As Panel
	pnl.Initialize("pnl")
	pnl.RemoveAllViews
	firstdayticks = DateUtils.SetDate(yr,mnth,1)
	Private startdaynumber As Int = DateTime.GetDayOfWeek(firstdayticks)	'1 = sunday, 7 = saturday
	' adjust for monday to sunday (seq = 1)
	If seq = 1 Then
		If startdaynumber = 1 Then
			startdaynumber = 7
		Else
			startdaynumber = startdaynumber - 1
		End If
	End If
	'
	Private enddaynumber As Int = DateUtils.NumberOfDaysInMonth(mnth,yr)
	Private lstmonthnames As List = Array As String("January","February","March","April","May","June","July","August","September","October","November","December")
	Private monthname As String = lstmonthnames.Get(mnth-1)
	Private lblmonth As Label = set_label(monthname & " " & yr, Colors.ARGB(100,182,221,249),"")
	pnl.AddView(lblmonth,leftpos,toppos,7*boxwidth,boxheight)
	Private lstdaynames As List
	lstdaynames.Initialize
	If seq = 1 Then
		lstdaynames = Array As String("Mo","Tu","We","Th","Fr","Sa","Su")
	Else
		lstdaynames = Array As String("Su","Mo","Tu","We","Th","Fr","Sa")
	End If
	For i = 1 To 7
		Private lbl As Label = set_label(lstdaynames.Get(i-1), Colors.ARGB(100,255,255,135),"")
		pnl.AddView(lbl,leftpos+boxwidth*(i-1),toppos+boxheight,boxwidth,boxheight)
	Next
	For r = 1 To 6
		For c = 1 To 7
			If c < startdaynumber And r = 1 Then
				Private lbl As Label = set_label("",Colors.ARGB(100,230,230,230),"")
			Else
				If daynumber > enddaynumber Then
					Private lbl As Label = set_label("", Colors.ARGB(100,230,230,230),"")
				Else
					If daynumber = currentday And mnth = currentmonth And yr = currentyear Then
						Private lbl As Label = set_label(daynumber, Colors.ARGB(100,255,50,50),"lblday")
					Else
						' test for sequence sunday to saturday (seq = 2)
						If seq = 2 Then
							If c = 1 Or c = 7 Then
								Private lbl As Label = set_label(daynumber, Colors.ARGB(100,255,210,179),"lblday")
							Else
								Private lbl As Label = set_label(daynumber,Colors.ARGB(100,158,255,150),"lblday")
							End If
						Else
							' monday to sunday (seq = 1)
							If c > 5 Then
								Private lbl As Label = set_label(daynumber, Colors.ARGB(100,255,210,179),"lblday")
							Else
								Private lbl As Label = set_label(daynumber,Colors.ARGB(100,158,255,150),"lblday")
							End If
						End If
					End If
					If File.Exists(folder,DateUtils.SetDate(yr,mnth,daynumber) & "_notes.txt") Then
						If daynumber = currentday And mnth = currentmonth And yr = currentyear Then
							Private lbl As Label = set_label(daynumber,Colors.ARGB(100,255,165,0),"lblday")
						Else
							Private lbl As Label = set_label(daynumber,Colors.ARGB(100,255,255,0),"lblday")
						End If
					End If
					lbl.Tag = DateUtils.SetDate(yr,mnth,daynumber)
					daynumber = daynumber + 1
				End If
			End If
			pnl.AddView(lbl,leftpos+boxwidth*(c-1),toppos+(boxheight*2)+boxheight*(r-1),boxwidth,boxheight)
		Next
	Next
	pnl.Width = 7 * boxwidth + 1dip
	pnl.Height = 8 * boxheight + 1dip
	Return pnl
End Sub
private Sub set_label(lbltext As String, intbackground As Int, lbltag As String) As Label
	Private lbl As Label
	lbl.Initialize(lbltag)
	lbl.Background = set_background(intbackground)
	lbl.Typeface = Typeface.DEFAULT_BOLD
	lbl.TextSize = 16
	lbl.Text = lbltext
	lbl.Gravity = Bit.Or(Gravity.CENTER_HORIZONTAL,Gravity.TOP)
	Return lbl
End Sub
Private Sub set_background(intcolor As Int) As StateListDrawable
	Private cd,cd2 As ColorDrawable
	Private sd As StateListDrawable
	cd.Initialize2(intcolor,5,1,Colors.Black)
	cd2.Initialize2(Colors.Red,5,1,Colors.Black)
	sd.Initialize
	sd.AddState(sd.State_Pressed,cd2)
	sd.AddState(sd.State_Enabled,cd)
	Return sd
End Sub
Public Sub lblday_Click
	Dim l As Label = Sender
	lblticks = l.tag
	lblseldate.Text = DateTime.Date(lblticks)
	If xui.SubExists(mCallback,mEventname & "_dayclick",2) Then
		CallSubDelayed(mCallback,mEventname & "_dayclick")
	End If
End Sub
Public Sub set_date_picker(intmonth As Int, intyear As Int) As Panel
	pnlpicker.Initialize("pnlpicker")
	pnlpicker.RemoveAllViews
	Private btnprev As Button = set_button("PREV",Colors.ARGB(100,182,221,249),"btnprev")
	pnlpicker.AddView(btnprev,0dip,0dip,70dip,40dip)
	lblseldate = set_label("",Colors.ARGB(100,230,230,230),"")
	pnlpicker.AddView(lblseldate,70dip,0dip,148dip,40dip)
	Private btnnext As Button = set_button("NEXT",Colors.ARGB(100,182,221,249),"btnnext")
	pnlpicker.AddView(btnnext,218dip,0dip,70dip,40dip)
	Private pnlmonth As Panel
	pnlmonth.Initialize("pnlmonth")
	pnlmonth = set_month_panel(intmonth,intyear,2)	' su - sa
	Private btntoday As Button = set_button("NOW",Colors.ARGB(100,182,221,249),"btntoday")
	pnlpicker.AddView(btntoday,0dip,40dip,70dip,40dip)
	pnlpicker.AddView(pnlmonth,0dip,40dip,278dip,368dip)
	pnlpicker.SetLayoutAnimated(0dip, 0dip, 0dip, 278dip, 368dip)
	Return pnlpicker
End Sub
Private Sub set_button(btntext As String, intbackground As Int, btntag As String) As Button
	Private btn As Button
	btn.Initialize(btntag)
	btn.Background = set_background(intbackground)
	btn.Typeface = Typeface.DEFAULT_BOLD
	btn.TextSize = 16
	btn.Text = btntext
	btn.Gravity = Bit.Or(Gravity.CENTER_HORIZONTAL,Gravity.CENTER_VERTICAL)
	Return btn
End Sub
Sub btnprev_Click
	If xui.SubExists(mCallback,mEventname & "_btnprevclick",2) Then
		CallSubDelayed(mCallback,mEventname & "_btnprevclick")
	End If
End Sub
Sub btnnext_Click
	If xui.SubExists(mCallback,mEventname & "_btnnextclick",2) Then
		CallSubDelayed(mCallback,mEventname & "_btnnextclick")
	End If
End Sub
Sub btntoday_Click
	If xui.SubExists(mCallback,mEventname & "_btntodayclick",2) Then
		CallSubDelayed(mCallback,mEventname & "_btntodayclick")
	End If
End Sub
